//---------------------------------------------------------------------------
// SingList.h
// 
// Written by:   ????
// Last Updated: ?????
//
// Description
//  - delete this line and write something appropriate and useful -
//
//  - changes to this file are required - delete this line too -
//
//---------------------------------------------------------------------------
#pragma once

#include <iostream>
using namespace std;

//---------------------------------------------------------------------------
// Template Declaration of NodeType
// No changes are required here.
//---------------------------------------------------------------------------
template <typename Type>
class NodeType 
{
   public:
      Type m_data;
      NodeType<Type> *mp_next;
      // note data goes uninitialized for default constructor
      // concept being Type's constructor would auto-init it for us
      NodeType() { mp_next = NULL; } 
      NodeType(Type data) { m_data = data; mp_next = NULL; }
};

//---------------------------------------------------------------------------
// Template DECLARATION of class SingList                    BEGINS
// 
// There is nothing in this section that should be changed
//
// Look farther below for where you must make changes
//
//---------------------------------------------------------------------------
template <typename T>
class SingList
{
   public:
      SingList();
         // constructor. create an empty list. no memory allocation needed
         // initialize any and all pointers to null
         
      ~SingList();
         // destructor. delete all elements (if any) from list

      void insertFront(NodeType<T> *newNode);
         // push (insert) item onto the front of the list.
         // Postcondition: the list has a new first element

      void removeFront();
         // remove the first item from the list.
         // if stack is empty, nothing is done

      void insertBack(NodeType<T> *newNode);
         // push (insert) item onto the end of the list.
         // Postcondition: the list has a new last element

      void removeBack();
         // remove the last item from the list.
         // if stack is empty, nothing is done

      T front();
         // returns a copy of the data stored in the front node
         // if list is empty returned value is whatever the
         // type T initializes to... so is mostly undefined behavior
         // this is a deviation from standard

      void printList();
         // print the contents of the list with each
         // element separated by a space
         // output a single endl after the last element
         // prints "is empty\n" if there are no elements in the list
         // This would almost be op<< overload
         
      void deleteList();
         // delete all elements from list
         // set mp_headPtr and mp_tailPtr to null
         // likely call this in the destructor
     
      bool empty() const;
         // return true if list is empty, else false

      int size() const;
         // return the number of elements in the list

   private:
      NodeType<T>  *mp_headPtr;
      NodeType<T>  *mp_tailPtr;
};

//---------------------------------------------------------------------------
// Template DECLARATION of class SingList                    ENDS
//
// Below you will find the DEFINITION of template class SingList
// This is a strange oddity in C++ that requires 
// the template declaration and template definition to be in the same file
//
// Technically this is all still declaration as the 
// complete definition does not occur until the type is specified...
// --- and then the compiler does all the work for you =)
//
// There is code you MUST fill-in for this assignment below
//
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Constructor
// Initialize member pointers to null
//---------------------------------------------------------------------------
template <typename T>
SingList<T>::SingList()
{

}

//---------------------------------------------------------------------------
// Destructor
// Delete all elements in the list
// Be sure member pointers are set to null (empty list)
//---------------------------------------------------------------------------
template <typename T>
SingList<T>::~SingList()
{
}

// ----------------------------------------------------------------------------
// insertFront
// Insert a node pointed to by newNode to the front of the list
// This requires proper updating of mp_headPtr and mp_tailPtr
// ----------------------------------------------------------------------------
template <typename T>
void SingList<T>::insertFront(NodeType<T> *newNode)
{
}

// ----------------------------------------------------------------------------
// removeFront
// Remove first node (head node) from the list
// This requires proper updating of mp_headPtr and mp_tailPtr
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
// insertBack
// Add a node to the end of the list
// This requires proper updating of mp_headPtr and mp_tailPtr
// ----------------------------------------------------------------------------



// ----------------------------------------------------------------------------
// removeBack
// Remove a node from the end of the list
// This requires proper updating of mp_headPtr and mp_tailPtr
// ----------------------------------------------------------------------------



// Check declaration section to see what other functions need implemented
// Delete this line and the above line


//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// file ends
